﻿<%@ Page language="c#" AutoEventWireup="false" codePage="1200" %>
<%@ Register TagPrefix="eb" Namespace="Soneta.Core.Web" Assembly="Soneta.Core.Web" %>
<%@ Register TagPrefix="ea" Namespace="Soneta.Web" Assembly="Soneta.Web" %>
<%@ import Namespace="Soneta.Types" %>
<%@ import Namespace="System.Collections.Generic" %>
<%@ import Namespace="Soneta.Place" %>
<%@ import Namespace="Soneta.Zadania" %>
<%@ import Namespace="Soneta.Business" %>
<%@ import Namespace="Enova.Place.KosztyProjektow" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<TITLE>lista płac - podział kosztów</TITLE>
		<script runat="server">
		    
            static bool hideOperator = false;
            static bool nazwaWNaglowku = false;

            string domyślnySymbol;
            string wymiarWynagrodzenie;
            string wymiarZUS;
            string wymiarPPK;
            Set<string> klucze = new Set<string>();    
            Dictionary<string, decimal> wynagrodzenia = new Dictionary<string, decimal>();
            Dictionary<string, decimal> narzutyZUS = new Dictionary<string, decimal>();
            Dictionary<string, decimal> narzutyPPK = new Dictionary<string, decimal>();

            void OnContextLoad(Object sender, EventArgs args) {
                ListaPlac listaPłac = (ListaPlac)dc[typeof(ListaPlac)];
                if (listaPłac.Bufor)
                    ReportHeader1["BUFOR"] = "Lista nie została zatwierdzona!|";
                else
                    ReportHeader1["BUFOR"] = "";

                if (nazwaWNaglowku)
                    ReportHeader1["NAZWA"] = listaPłac.Definicja.Nazwa + "|";
                else
                    ReportHeader1["NAZWA"] = "";

                if (hideOperator)
                    stOperator.SubtitleType = SubtitleType.Empty;

                Log log = new Log("Opis analityczny", true);

                Config config = Config.Create(dc);
                domyślnySymbol = config.DomyślnySymbol;
                wymiarWynagrodzenie = config.WymiarWynagrodzenie;
                wymiarZUS = config.WymiarNarzuty;
                wymiarPPK = config.WymiarPPK;

                if (config.TypCechy == TypCechy.Tekst) {
                    OpisAnalitycznyListyPłac<string> generator = new OpisAnalitycznyListyPłac<string>(listaPłac.Wyplaty, log);
                    foreach (KeyValuePair<MyTuple<string, string>, decimal> element in generator.PodzielKoszty(config.NazwaCechy, config.WymiarWynagrodzenie, config.WymiarNarzuty, config.WymiarPPK))
                        Dodaj(element.Key, element.Value);                    
                }
                else {
                    OpisAnalitycznyListyPłac<Projekt> generator = new OpisAnalitycznyListyPłac<Projekt>(listaPłac.Wyplaty, log);
                    foreach (KeyValuePair<MyTuple<Projekt, string>, decimal> element in generator.PodzielKoszty(config.NazwaCechy, config.WymiarWynagrodzenie, config.WymiarNarzuty, config.WymiarPPK))
                        Dodaj(element.Key, element.Value);                    
                }

                List<string> lstk = new List<string>(klucze);
                lstk.Sort();
                Grid.DataSource = lstk;
            }

            void Dodaj(IMyTuple key, decimal nowa) {
                string klucz = key[0] == null ? "" : key[0].ToString();
                if (klucz == "")
                    klucz = domyślnySymbol;
                string wymiar = (string)key[1];
                klucze.Add(klucz);
                if (nowa != 0) {
                    Dictionary<string, decimal> dct = (wymiar == wymiarWynagrodzenie ? wynagrodzenia : (wymiar == wymiarZUS ? narzutyZUS : narzutyPPK));
                    decimal kwota;
                    dct.TryGetValue(klucz, out kwota);
                    dct[klucz] = kwota + nowa;
                }
            }

            protected void Grid_BeforeRow(object sender, RowEventArgs args) {
                string key = (string)args.Row;
                colKey.EditValue = key;
                
                decimal v;

                wynagrodzenia.TryGetValue(key, out v);
                colValue.EditValue = v;

                narzutyZUS.TryGetValue(key, out v);
                colZUS.EditValue = v;

                narzutyPPK.TryGetValue(key, out v);
                colPPK.EditValue = v;
            }
</script>
		<META content="C#" name="CODE_LANGUAGE">
		<META content="JavaScript" name="vs_defaultClientScript">
		<META content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">
	</HEAD>
	<BODY>
		<FORM method="post" runat="server">
			<ea:DataContext id="dc" runat="server" oncontextload="OnContextLoad" TypeName="Soneta.Place.ListaPlac, Soneta.KadryPlace"></ea:DataContext>
			<eb:reportheader id="ReportHeader1" title="Lista płac {0}|Podział kosztów|%NAZWA%%BUFOR%</strong>Wydział:<strong> {1}|</strong>Za okres:<strong> {2}|</strong>Data wypłaty:<strong> {3}"
				runat="server" DataMember2="Okres" DataMember1="Wydzial" DataMember0="Numer" DataMember3="DataWyplaty"></eb:reportheader>
			<ea:Grid id="Grid" runat="server" 
                RowTypeName="Soneta.Kalend.DzienPracy,Soneta.KadryPlace" 
                onbeforerow="Grid_BeforeRow">
				<Columns>
					<ea:GridColumn Width="4" Align="Right" DataMember="#" Caption="LP."></ea:GridColumn>
					<ea:GridColumn runat="server" ID="colKey" Caption="Projekt" Total="Info" 
                        EncodeHTML="True"></ea:GridColumn>
				    <ea:GridColumn runat="server" Align="Right" ID="colValue" 
                        Caption="Wynagrodzenia" Total="Sum"></ea:GridColumn>
				    <ea:GridColumn runat="server" Align="Right" ID="colZUS" Caption="Narzuty ZUS" 
                        Total="Sum"></ea:GridColumn>
					<ea:GridColumn runat="server" Align="Right" ID="colPPK" Caption="Narzuty PPK" 
                        Total="Sum"></ea:GridColumn>
				</Columns>
			</ea:Grid>
			<eb:ReportFooter id="ReportFooter1" runat="server">
				<Subtitles>
					<eb:FooterSubtitle Caption="Sprawdzono pod względem merytorycznym" SubtitleType="DataPodpis" Width="50"></eb:FooterSubtitle>
					<eb:FooterSubtitle Caption="Sprawdzono pod względem formalno prawnym" SubtitleType="DataPodpis" Width="50"></eb:FooterSubtitle>
					<eb:FooterSubtitle ID="stOperator" SubtitleType="Operator"></eb:FooterSubtitle>
					<eb:FooterSubtitle Caption="data"></eb:FooterSubtitle>
					<eb:FooterSubtitle Caption="gł&#243;wny księgowy"></eb:FooterSubtitle>
					<eb:FooterSubtitle Caption="kierownik jednostki"></eb:FooterSubtitle>
				</Subtitles>
			</eb:ReportFooter>
		</FORM>
	</BODY>
</HTML>
